﻿import wx;
import Scripts.Utils as Utils;
from Scripts.MethodEntry import MethodEntry

class MainWindow:
    
    app=None;
    window=None;
    panel=None;
    NumberTextCtrl=None;
    FrameLength=20;
    GridSizeX=100;
    GirdSizeY=30;
    safeWidth=0;
    safeHeight=0;

    def Init(title:str):
        MainWindow.app=wx.App();        
        MainWindow.window = wx.Frame(None, title = title, size = (300,200))
        MainWindow.panel = wx.Panel(MainWindow.window)
        
        #生成一个数字输入窗口
        wx.StaticText(MainWindow.panel,label='请输入内容',pos=(20,10));
        MainWindow.NumberTextCtrl = wx.TextCtrl(MainWindow.panel,wx.ID_ANY,"0",(85,10),(200,20));

        pass;
    
    def SetSize(width,height : int):
        MainWindow.window.Size=(width,height);
        MainWindow.safeWidth=width-MainWindow.FrameLength;
        MainWindow.safeHeight=height-MainWindow.safeHeight;
        pass; 

    def Run():
        MainWindow.window.Show(True)
        MainWindow.app.MainLoop()
        pass;
    
    ListEntry=[];
    
    def AddMethodEntry(entry : MethodEntry):                
        MainWindow.ListEntry.append(entry);
        MainWindow.UpdateWindow();
        pass;

    def AddMethodEntryList(entryList:[]):        
        for x in entryList:
            MainWindow.ListEntry.append(x);    
        MainWindow.UpdateWindow();
        pass;

    def UpdateWindow():
        #刷新窗口
        length=int(MainWindow.ListEntry.count(MainWindow.ListEntry));
        print("当前有按钮："+str(length));        

        #刷新按钮
        height=MainWindow.FrameLength+100;
        width=MainWindow.FrameLength+10;
        for x in MainWindow.ListEntry:
            MainWindow.CreateButton(x,width,height);
            height=height+MainWindow.GirdSizeY;
            pass
        pass;    

    def CreateButton(entry : MethodEntry,x,y:int):
        btnLabel=entry.GetMethodName();
        print("添加按钮："+btnLabel)
        btn=wx.Button(MainWindow.panel,-1,btnLabel,pos=(x,y));
        btn.Bind(wx.EVT_LEFT_DOWN,entry.RunMethod);
        pass;